<?php
/*
Plugin Name: XLT
Plugin URI: http://www.pagasa.net/plugin-seo-pour-wordpress/
Description: Plugin SEO multi-fonction: capture de longue traine, auto-tagging, indexation, etc.
Author: Thibaut Maquet
Version: 1.5
Author URI: http://www.pagasa.net/
*/

// 19-jul-2013: Version 1.5
//
// 15-jul-2013: Ajout des Supertags
//
// 14-jul-2013: Ajout des blacklist
//
// 27-jui-2013: Petit bug sur l'affichage du total des mots-cles
//
// 01-mai-2013: Version 1.4
//
// 28-avr-2013: Le widget est entierement parametrable au niveau HTML
//
// 26-avr-2013: 
//	- Les mots-cles peuvent etre desormais dissimules
//	- L'affichage des mots-cles est optionnel sur la page principale
//	- L'affichage des mots-cles sur les extraits est desormais optionnel (ouf!)
//	- Ajout d'autres moteurs de recherche pour pouvoir recuperer plus de mots-cles
//	- Petit bug corrige lorsque le mot-cle contient une apostrophe
//
// 09-jan-2013: Version 1.3 - modification cosmetique du panneau d'admin - ajout de l'archivage
//
// 09-nov-2012: Version 1.25 - ajout du nombre de mot cles recenses par jour
//
// 27-jui-2012: Version 1.2
//
// 26-jui-2012: Modification de l'algorithme de l'affichage des liens dans le widget
//
// 22-jui-2012: Ajout des totaux
//
// 14-jui-2012: Ajout de l'affichage glissant des mots-cles
//
// 01-sep-2011: Version 1.1
//
// 30-aou-2011: Modification de l'algorithme de l'affichage des liens dans le widget.
//
// 29-aou-2011: Division par zero sur les campagnes, modification du widget qui fait planter
// certains themes.
//
// 28-aou-2011: Probleme avec les CREATE TABLES sur certaines implementation MySQL
//
// 27-aou-2011: Petit bug sur les permaliens du widget.
//
// 21-aou-2011: Version 1.0

function pk_init() {
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

  global $wpdb;

  $tname = $wpdb->prefix . "pk_bl";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(10) NOT NULL auto_increment,
    `bl` varchar(255) NOT NULL default '',
    PRIMARY KEY  (`id`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_supertag";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `tagid` varchar(10) NOT NULL default '',
    `postid` varchar(10) NOT NULL default '',
    PRIMARY KEY  (`tagid`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_kw";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `kw` varchar(120) NOT NULL default '',
    `ts` varchar(20) NOT NULL default '',
    `ts2` varchar(20) NOT NULL default '',
    `postid` varchar(10) NOT NULL default '',
    `opt` varchar(2) NOT NULL default '',
    `cid` int(11) NOT NULL,
    `gid` int(11) NOT NULL,
    PRIMARY KEY  (`id`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_camp";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `name` varchar(20) NOT NULL default '',
    `kw` varchar(50) NOT NULL default '',
    `ads` text NOT NULL,
    `link` varchar(100) NOT NULL default '',
    `opt` varchar(2) NOT NULL default '',
    `misc` varchar(100) NOT NULL default '',
    PRIMARY KEY  (`id`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_ip";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `ip` varchar(30) NOT NULL default '',
    `ts` varchar(20) NOT NULL default '',
    PRIMARY KEY  (`ip`)
    );";
    dbDelta($sql);
  }

  if (!wp_next_scheduled('pk_hook'))
    wp_schedule_event( time(), 'daily', 'pk_hook' );

  add_option('pk_prefs_article','20','','yes');
  add_option('pk_prefs_purge','1','','yes');
  add_option('pk_prefs_purge_day','20','','yes');
  add_option('pk_prefs_sortop','0','','yes');
  add_option('pk_prefs_disarticle','1','','yes');
  add_option('pk_prefs_numarticle','5','','yes');
  add_option('pk_prefs_methode','1','','yes');
  add_option('pk_prefs_ntg','10','','yes');
  add_option('pk_prefs_tg','1','','yes');
  add_option('pk_prefs_hdr',XLT_TXT001,'','yes');
  add_option('pk_prefs_gl','1','','yes');
  add_option('pk_seq','0','','yes');
  add_option('pk_wid','','','yes');
  add_option('pk_prefs_wid1','5','','yes');
  add_option('pk_prefs_wid2','5','','yes');
  add_option('pk_prefs_archivage','1','','yes');
  add_option('pk_prefs_excerpt','1','','yes');
  add_option('pk_prefs_home','1','','yes');
  add_option('pk_prefs_hide','0','','yes');
  add_option('pk_prefs_wid_hd1','<ul>','','yes');
  add_option('pk_prefs_wid_hd2','<li>','','yes');
  add_option('pk_prefs_wid_hd3','</li>','','yes');
  add_option('pk_prefs_wid_hd4','</ul>','','yes');
  add_option('pk_prefs_supertag','0','','yes');
}


function pk_deinit() {
  
  wp_clear_scheduled_hook('pk_hook');

  delete_option('pk_prefs_supertag');
  delete_option('pk_prefs_wid_hd1');
  delete_option('pk_prefs_wid_hd2');
  delete_option('pk_prefs_wid_hd3');
  delete_option('pk_prefs_wid_hd4');
  delete_option('pk_prefs_hide');
  delete_option('pk_prefs_home');
  delete_option('pk_prefs_excerpt');
  delete_option('pk_prefs_archivage');
  delete_option('pk_prefs_article');
  delete_option('pk_prefs_purge');
  delete_option('pk_prefs_purge_day');
  delete_option('pk_prefs_sortop');
  delete_option('pk_prefs_disarticle');
  delete_option('pk_prefs_numarticle');
  delete_option('pk_prefs_methode');
  delete_option('pk_prefs_tg');
  delete_option('pk_prefs_ntg');
  delete_option('pk_prefs_hdr');
  delete_option('pk_prefs_gl');
  delete_option('pk_seq');
  delete_option('pk_wid');
  delete_option('pk_wid_data');
  delete_option('pk_wid_first');
  delete_option('pk_prefs_wid1');
  delete_option('pk_prefs_wid2');
}

function pk_styles() {
  wp_register_style('custom-style', plugins_url('/xlt.css',__FILE__ ));
  wp_enqueue_style('custom-style'); 
}

function pk_log($txt) {
  $fd = fopen(ABSPATH ."wp-content/plugins/xlt/debug.log","a");
  $date = sprintf("%4d-%02d-%02d %02d:%02d:%02d",date('Y'),date('n'), date('d') , date('H'),date('i'),date('s'));
  $t=sprintf("$date $txt\n");
  fwrite($fd,$t);
  fclose($fd);
}

function pk_taggme($mk) {
  global $wpdb;

  if(get_option('pk_prefs_tg') == '0')
    return 1;

  $mkwse = urldecode($mk);
  $mid = get_the_ID();
  if($mid) {
    $mtags = wp_get_post_tags($mid);
    $n = 0;
    $mt = "";
    $mtg = "";
    foreach($mtags as $mtag) {
      $n++;
      $mtg .= $mtag->name. ",";
      if(strcmp(strtolower($mtag->name),strtolower($mkwse))) {
        $mt = $mkwse;
        if(strstr($mt,"."))
          $mt = "";
      }
    }
    if(strlen($mt) && $n < get_option('pk_prefs_ntg')) {
      $mtg .= $mt;
      wp_set_post_tags($mid,$mtg);
    }
    else {
      if(!$n)
        wp_set_post_tags($mid,$mkwse);
    }
  }
}

function pk_se() {
  $mref=$_SERVER["HTTP_REFERER"];
  $mk = "";
  $mse = array();
  $mse[0][0] = ".google.";
  $mse[0][1] = "q=";
  $mse[1][0] = ".search.yahoo.";
  $mse[1][1] = "p=";
  $mse[2][0] = ".voila.fr";
  $mse[2][1] = "rdata=";
  $mse[3][0] = ".bing.fr";
  $mse[3][1] = "q=";
  $mse[3][0] = ".ask.com";
  $mse[3][1] = "q=";
  $mse[4][0] = "isearch.avg.com";
  $mse[4][1] = "q=";
  $mse[5][0] = "search.sweetim.com";
  $mse[5][1] = "q=";
  $mse[6][0] = "search.conduit.com";
  $mse[6][1] = "q=";
  $mse[7][0] = "search.babylon.com";
  $mse[7][1] = "q=";
  $mse[8][0] = ".dogpile.com";
  $mse[8][1] = "q=";
  $mse[9][0] = ".delta-search.com";
  $mse[9][1] = "q=";
  $mse[10][0] = ".mysearchresults.";
  $mse[10][1] = "q=";
  $mse[11][0] = ".aol.";
  $mse[11][1] = "q=";
  $mse[12][0] = ".incredimail.";
  $mse[12][1] = "q=";

  $i = 0;
  $ms = "";
  $mq = "";
  foreach ($mse as $v1) {
    $q = strstr($mref,$mse[$i][0]);
    if(strlen($q)) {
      $ms = $mse[$i][0];
      $mq = $mse[$i][1];
      break;
    }
    $i++;
  }

  if(strlen($ms)){
    $q = strstr($mref,"&".$mq);
    if(strlen($q)) {
      $tab = split("&".$mq,$mref);
      $mk = $tab[1];
      $tab =  split("&",$mk);
      $mk = $tab[0];
      if (strlen($mk))
        $mk = urldecode($mk);
      else
        $mk = "-1";
    }
    else {
      $q = strstr($mref,"?".$mq);
      if(strlen($q)) {
        $tab = split("\?".$mq,$mref);
        $mk = $tab[1];
        $tab =  split("&",$mk);
        $mk = $tab[0];
        $mk = urldecode($mk);
      }
    }
  }
  return $mk;
}


function pk_filter($mct) {
  global $wpdb;
  $mc = "";
  $mmse = pk_se();

  global $mpk_filter;

  if(strlen($mmse) && $mmse != "-1") {
    pk_taggme($mmse);
    $mip = getenv('REMOTE_ADDR');
    $mi = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_ip WHERE ip = '".$mip."'");
    if(!$mi) {
      $sql = "INSERT INTO ".$wpdb->prefix . "pk_ip ( `ip`,`ts`) VALUES ('".$mip."','".mktime()."')";
      $wpdb->query($sql);
      $mkwse = urldecode($mmse);
      $mk1 = strtolower($mkwse);
      $ok = 1;
      $sql1 = $wpdb->get_results("SELECT bl FROM ".$wpdb->prefix . "pk_bl");
      foreach ($sql1 as $res1) {
        $mk2 = strtolower(base64_decode($res1->bl));
        if(strstr($mk1,$mk2)) {
          $ok = 0;
          pk_log($mkwse);
        }
      }
      $mt = mktime();
      $sql = "INSERT INTO ".$wpdb->prefix . "pk_kw ( `kw`,`ts`,`postid`) VALUES (";
      if(strstr($mkwse,"'"))
        $sql .= '"'.$mkwse.'"';
      else
        $sql .= "'".$mkwse."'";
      $sql .= ",'".$mt."','".get_the_ID()."')";
      if($ok)
        $wpdb->query($sql);
      $sql = "SELECT id FROM ".$wpdb->prefix . "pk_kw WHERE ts = '".$mt."' AND kw =";
      if(strstr($mkwse,"'"))
        $sql .= '"'.$mkwse.'"';
      else
        $sql .= "'".$mkwse."'";
      $sql = $wpdb->get_results($sql);
      foreach ($sql as $res) {
        $mid = $res->id;
      }
      $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_camp");
      foreach ($sql as $res) {
        $mkwcamp = $res->kw;
        $mk = explode(" ",$mkwcamp);
        $j = count($mk);
        $i = 0;
        foreach($mk as $li) {
          if(strstr($mkwse,$li))
            $i++;
        }
        if($i>=$j) {
          $mads = stripslashes(base64_decode($res->ads));
          $mcid = $res->id;
          $mc = '<a href="http://'.getenv("HTTP_HOST")."/ck.php?id1=".$mcid."&id2=".$mid."&ts=".$mt.'">'.$mads."</a>\n";
          $sql = "UPDATE ".$wpdb->prefix . "pk_kw SET `cid` = '".$mcid."' WHERE `ts` = '".$mt."' AND `kw` = '".$mkwse."'";
          $wpdb->query($sql);
        }
      }
   
      $mpurge = get_option('pk_prefs_purge');
      if(strlen($mpurge)) {
        $mts = get_option('pk_prefs_purge_day');
        $mts =  mktime() - (60 * 60 * 24 * $mts);
        $marchivage = get_option('pk_prefs_archivage');
        if(strlen($marchivage)) {
          $fd = fopen(ABSPATH ."wp-content/plugins/xlt/xlt.csv","a");
          if($fd) {
            $a = "SELECT * FROM `".$wpdb->prefix . "pk_kw` WHERE ts < ".$mts;
            $sql = $wpdb->get_results($a);
            foreach ($sql as $res) {
              $mpost = get_post($res->postid);
              $t = strftime(XLT_TXT020." ".XLT_TXT019,$res->ts).";http://".getenv("HTTP_HOST")."/".$mpost->post_name.";".$res->kw."\n";
              fwrite($fd,$t);
            }
            fclose($fd);
          } 
        }
        $sql = "DELETE FROM ".$wpdb->prefix . "pk_kw WHERE ts < ".$mts;
        $wpdb->query($sql);
      }
    }
  }
  $mts =  mktime() - (60 * 5);
  $sql = "DELETE FROM ".$wpdb->prefix . "pk_ip WHERE ts < ".$mts;
  $wpdb->query($sql);
  $mct = $mc . $mct;

  $mdisart = get_option('pk_prefs_disarticle');
  if($mdisart == '1') {
    $t = "";  
    $mtd = get_option('pk_prefs_methode');
    switch($mtd) {
      case 1:
        $a = "SELECT count(*),kw FROM `".$wpdb->prefix . "pk_kw` WHERE postid = " .get_the_ID()." GROUP BY kw ORDER BY 1 DESC LIMIT ".get_option('pk_prefs_numarticle');
        break;
      case 2:
        $a = "SELECT kw FROM `".$wpdb->prefix . "pk_kw` WHERE postid = " .get_the_ID()." GROUP BY kw ORDER BY ts DESC LIMIT ".get_option('pk_prefs_numarticle');
        break;
      case 3:
        $j = 1;
        $a = "SELECT kw FROM `".$wpdb->prefix . "pk_kw` WHERE postid = " .get_the_ID()." GROUP BY kw";
        $sql = $wpdb->get_results($a);
        foreach ($sql as $res) {
          $mkw[$j++] = $res->kw;
        }
        $l = get_option('pk_prefs_numarticle');
        for($k=0;$k<$l;$k++) {
          for($i=$j-1;$i>0;$i--) {
            if(strlen($mkw[$i])>strlen($mkw[$i-1])&&$i!=1) {
              $v = $mkw[$i];
              $mkw[$i] = $mkw[$i-1];
              $mkw[$i-1] = $v;
            }
          }
        }
        if($j-1 > get_option('pk_prefs_numarticle'))
          $j = 1+get_option('pk_prefs_numarticle');
        for($i=1;$i<$j;$i++)
          $t .= $mkw[$i].", ";
        break;
    }  
    if($mtd == 1 || $mtd == 2) {
      $sql = $wpdb->get_results($a);
      foreach ($sql as $res) {
        $t .= $res->kw.", ";
      }
    }
    $t = substr($t, 0, - 2);
    if(get_option('pk_prefs_excerpt') == '1')
      $ok = 1;
    else {
      $mpost = get_post(get_the_ID());
      $i = strlen($mpost->post_content);
      $j = strlen($mct);
      if($j < $i)
        $ok = 0;
      else
        $ok = 1;
    }
    if(is_home() && get_option('pk_prefs_home') == '0')
      $ok = 0;
    if($ok) {
      if(!$mpk_filter) {
        if(strlen($t)) {
          if(get_option('pk_prefs_hide') == '1')
            $mct .= '<div class="xlt-style">';
          $mct .= get_option('pk_prefs_hdr');
          $mct .= ": ";
        }
        $mct .= $t;
        if(get_option('pk_prefs_hide') == '1')
          $mct .= "</div>";
      }
    }
  }
  
  $msupertag = get_option('pk_prefs_supertag');
  if($msupertag == '1') {
    if(!$mpk_filter) {
      if(is_tag()) {
        $pid = get_the_ID();
        $tagid = $wpdb->get_var("SELECT tagid FROM ".$wpdb->prefix . "pk_supertag WHERE postid = '".$pid."'");
        if($tagid) {
          $mt = get_queried_object()->term_id;
          if($mt == $tagid) {
            $mct = "";
            $mname = get_queried_object()->name;
            $category = get_the_category();
            $mdesc = $category[0]->description;
            $a = "";
            if(strlen($mdesc)) {
              $a .= '<h1><a href="'.get_permalink($pid).'" title="'.$mname.'">'.$mname."</a></h1>";
              $a .= $category[0]->description;
            }
            $cid = $category[0]->term_id;
            $args = array('category' => $cid,'orderby' => 'post_date');
            $mps = get_posts($args);
            $n = 0;
            foreach($mps as $mp)  { 
              $tab[$n][0] = $mp->ID;
              $tab[$n][1] = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = '".$mp->ID."'");
              $n++;
            }
            if($n) {
              for($j=0;$j<$n-1;$j++) {
                for($k=0;$k<$n-1;$k++) {
                  if($tab[$k][1] < $tab[$k+1][1]) {
                    $t1 = $tab[$k][1];
                    $tab[$k][1] = $tab[$k+1][1];
                    $tab[$k+1][1] = $t1;
                    $t1 = $tab[$k][0];
                    $tab[$k][0] = $tab[$k+1][0];
                    $tab[$k+1][0] = $t1;
                  }
                }
              }
              $pid = $tab[$n-1][0];
              if(strlen($pid)) {
                $mp = get_post($pid);
                $mex = $mp->post_excerpt;
                if(strlen($mex)) {
                  $mname = $mp->post_title;
                  $a .= '<h2><a href="'.get_permalink($pid).'" title="'.$mname.'">'.$mp->post_title."</a></h2>";
                  $a .= $mex;
                }
              }
              if($n > 1) {
                if($n == 2)
                  $k = 1;
                else
                   if($n == 3)
                     $k = 2;
                   else
                     $k = 3;
                for($j=0;$j<$k;$j++) {
                  $pid = $tab[$j][0];
                  if(strlen($pid)) {
                    $mp = get_post($tab[$j][0]);
                    $mex = $mp->post_excerpt;
                    if(strlen($mex)) {
                      $mname = $mp->post_title;
                      $a .= '<h3><a href="'.get_permalink($pid).'" title="'.$mname.'">'.$mp->post_title."</a></h3>";
                      $a .= $mex;
                    }
                  } 
                }
                if($n > 3) {
                  for($j=3;$j<$n-1;$j++) {
                    $pid = $tab[$j][0];
                    if(strlen($pid)) {
                      $mp = get_post($tab[$j][0]);
                      $mex = $mp->post_excerpt;
                      if(strlen($mex)) {
                        $mname = $mp->post_title;
                        $a .= '<h4><a href="'.get_permalink($pid).'" title="'.$mname.'">'.$mp->post_title."</a></h4>";
                        $a .= $mex;
                      }
                    }
                  }
                }
              }
            }
            echo $a;
          }
        }
      }
    }
  }

  $mpk_filter++;
  return $mct;
}

function pk_admin_settings() {
  if (function_exists('add_options_page')){
    add_options_page("XLT", "XLT", 'manage_options', 'xlt-pid', "pk_display_settings");
  }
}

function pk_admin_del($mid) {
  global $wpdb;
  $sql = "DELETE FROM ".$wpdb->prefix . "pk_camp WHERE id = ".$mid;
  $wpdb->query($sql);
  $sql = "UPDATE ".$wpdb->prefix . "pk_kw SET `cid` = '0',`gid` = '0' WHERE `cid` = '".$mid."'";
  $wpdb->query($sql);
  return pk_admin_menu(XLT_TXT002);
}

function pk_admin_update($mid) {
  global $wpdb;
  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);

  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_camp WHERE id = ".$mid);
  foreach ($sql as $res) {
    $mname = $res->name;
    $mkw = $res->kw;
    $mads = $res->ads;
    $mlink = $res->link;
  }

  $a ="<h3>".XLT_TXT003."</h3>";

  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=mod&id=".$mid.'" method="post">';
  $a .= "<tr><td>";
  $a .= XLT_TXT004." : ";
  $a .= '<input type="text" size="20" maxlength="20" name="nom" value="'.$mname.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT005." : ";
  $a .= '<input type="text" size="50" maxlength="100" name="kw" value="'.$mkw.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT006." : ";
  $a .= "</td></tr>";
  $a .= '<tr><td><textarea rows="3" cols="100" name="ads">'.stripslashes(base64_decode($mads)).'</textarea>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT007." : ";
  $a .= '<input type="text" size="50" maxlength="100" name="link" value="'.$mlink.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" value="'.XLT_TXT008.'">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";

  echo $a;
}

function pk_admin_mod($mid) {
  if(isset($_POST['nom'])){
    $mname = $_POST['nom'];
    if(!strlen($mname))
      return pk_admin_menu(XLT_TXT009);
    if(isset($_POST['kw'])){
      $mkw = $_POST['kw'];
      if(!strlen($mkw))
        return pk_admin_menu(XLT_TXT010);
      if(isset($_POST['ads'])){
        $mads = $_POST['ads'];
        if(!strlen($mads))
          return pk_admin_menu(XLT_TXT011);
        if(isset($_POST['link'])){
          $mlink = $_POST['link'];
          if(!strlen($mlink))
            return pk_admin_menu(XLT_TXT012);
          global $wpdb;
          $mads = base64_encode($mads);
          $sql = "UPDATE ".$wpdb->prefix . "pk_camp SET `name` = '".$mname."',`kw` = '".$mkw."',`ads` = '".$mads."',`link` = '".$mlink."' WHERE `id` = '".$mid."'";
          $wpdb->query($sql);
          return pk_admin_menu(XLT_TXT013);
        }
        else
          return pk_admin_menu(XLT_TXT012);
      }
      else
        return pk_admin_menu(XLT_TXT011);
    }
    else
      return pk_admin_menu(XLT_TXT010);
  }
  else
    return pk_admin_menu(XLT_TXT009);
}

function pk_admin_add() {
  if(isset($_POST['nom'])){
    $mname = $_POST['nom'];
    if(!strlen($mname))
      return pk_admin_menu(XLT_TXT009);
    if(isset($_POST['kw'])){
      $mkw = $_POST['kw'];
      if(!strlen($mkw))
        return pk_admin_menu(XLT_TXT010);
      if(isset($_POST['ads'])){
        $mads = $_POST['ads'];
        if(!strlen($mads))
          return pk_admin_menu(XLT_TXT011);
        if(isset($_POST['link'])){
          $mlink = $_POST['link'];
          if(!strlen($mlink))
            return pk_admin_menu(XLT_TXT012);
          global $wpdb;
          $mads = base64_encode($mads);
          $sql = "INSERT INTO ".$wpdb->prefix . "pk_camp ( `name`,`kw`,`ads`,`link`,`opt`) VALUES ('".$mname."','".$mkw."','".$mads."','".$mlink."','1')";
          $wpdb->query($sql);
          return pk_admin_menu(XLT_TXT014);
        }
        else
          return pk_admin_menu(XLT_TXT012);
      }
      else
        return pk_admin_menu(XLT_TXT011);
    }
    else
      return pk_admin_menu(XLT_TXT010);
  }
  else
    return pk_admin_menu(XLT_TXT009);
}

//
// Status
//

function pk_admin_status($mout) {

  $a = "";
  if(strlen($mout)) {
    $a = "";
    $a .= '<div class="postbox">';
    $a .= "<h3>Status</h3>\n";
    $a .= '<div class="inside">';
    $a .= '<table style="border: #cccccc 1px outset;" border="1" cellspacing="1" cellpadding="3" width="75%">'."\n";
    $a .= "<tr><td>\n";
    $a .= $mout;
    $a .= "</td></tr></table>\n";
    $a .= "</div></div>";
  }
  return $a;
}

function pk_clic($mid) {
  global $wpdb;

  $a = "";
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT015."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .= "<tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT017."</b></center></td><td><center><b>".XLT_TXT018." </b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE gid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a . "<tr>";
    $a .= "<td>".strftime(XLT_TXT020." ".XLT_TXT019,$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".strftime(XLT_TXT020." ".XLT_TXT019,$res->ts2)."&nbsp;&nbsp;</td>";
    $a .= "</tr>";
  }
  $a .= "</table>";
  $a .= "</div></div>";
  echo $a;
}

function pk_print($mid) {
  global $wpdb;
  $a = "";
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT021."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .= "<tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT017."</b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE cid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a . "<tr>";
    $a .= "<td>".strftime(XLT_TXT020." ".XLT_TXT019,$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."</td>";
    $a .= "</tr>";
  }
  $a .= "</table>";
  $a .= "</div></div>";
  echo $a;
}

function pk_admin_menu($mout) {
  global $wpdb;

  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&st=(.*)+/","",$mrequrl);

  if(strlen($mout))
    echo pk_admin_status($mout);

// Stats sur les mot cle

  $mp = get_option('pk_prefs_sortop');
  if($mp)
    $mst = 0;
  else
    $mst = 1;

  $mp = get_option('pk_prefs_gl');
  if($mp == '1') {
    $date = sprintf("%4d-%02d-%02d",date('Y'),date('n'), date('d'));
    $dt = strtotime($date);
  }
  else
    $dt = mktime() - 60 * 60 * 24;

  $nb = get_option('pk_prefs_article');
  $a = "";
  $a .= '<div class="postbox-container" style="width: 80%">';
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT022."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT023."</b></center></td><td><center><b><a href=".'"'.$mrequrl."&op=kwv".'"'.">".XLT_TXT017."&nbsp;&nbsp;&nbsp;</a></b></center></td><td><center><b><a href=".'"'.$mrequrl."&st=".$mst.'"'.">".XLT_TXT024."</a></b></center></td><td><center><b>".XLT_TXT075."</b></center></td></tr><tr>";
  if($mst) 
    $sql = $wpdb->get_results("SELECT postid, COUNT(postid) FROM `".$wpdb->prefix ."pk_kw` WHERE ts > '".$dt."' GROUP BY postid ORDER BY 2 DESC LIMIT ".$nb);
  else
    $sql = $wpdb->get_results("SELECT postid,COUNT(postid) FROM ".$wpdb->prefix . "pk_kw GROUP BY postid ORDER BY 2 DESC LIMIT ".$nb);
  $mtt1 = 0;
  $mtt2 = 0;
  foreach ($sql as $res) {
    $mpost = get_post($res->postid);
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$res->postid);
    $md = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$res->postid." AND ts > '".$dt."'");
    $mtt1 = $mtt1 + $mc;
    $mtt2 = $mtt2 + $md;
    $me = "X";
    $mtgid = $wpdb->get_var("SELECT tagid FROM ".$wpdb->prefix . "pk_supertag WHERE postid = ".$res->postid);
    if($mtgid) {
      $mtag = get_tag($mtgid);
      $me = $mtag->name;
    }
    $a .= "<tr>";
    $a .= "<td>".strftime(XLT_TXT020." ".XLT_TXT019,strtotime($mpost->post_date))."&nbsp;&nbsp;&nbsp;</td>";
    $a .= '<td><a href="http://'.getenv("HTTP_HOST").'/?p='.$res->postid.'" target="_blank">'.$mpost->post_title.'</a></td>';
    $a .= '<td><a href="'.$mrequrl."&op=kws&id=".$res->postid.'"><center>'.$mc."</center></a></td>";
    $a .= "<td><center>".$md."</center></td>";
    $a .= '<td><a href="'.$mrequrl."&op=tag&id=".$res->postid.'"><center>'.$me."</center></a></td>";
    $a .= "</tr>\n";
  }
  $a .='<tr><td></td><td><center>===</center></td><td><center><b><a href="'.$mrequrl.'&op=tot">'.$mtt1."</a></b></center></td><td><center><b>".$mtt2."</b></center></td></tr>";
  $a .= "</table>";
  $a .= "</div></div>";

// Stats sur les campagnes

  $a .= '<div class="postbox">';
  $a .="<h3>".XLT_TXT025."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $sql = $wpdb->get_results("SELECT id,name FROM ".$wpdb->prefix . "pk_camp");
  $a .= "<tr><td><center><b>".XLT_TXT004."</b></center></td><td><center><b>".XLT_TXT026."&nbsp;&nbsp;&nbsp;</b></center></td><td><center><b>".XLT_TXT027."&nbsp;&nbsp;</b></center></td><td><center><b>".XLT_TXT028."&nbsp;&nbsp;&nbsp;</b></center></td><td><center><b>".XLT_TXT029."</b></center></td></tr>\n";
  foreach ($sql as $res) {
    $mid = $res->id;
    $a .= "<tr>";
    $a .= "<td>".$res->name."&nbsp;&nbsp;</td>\n";
    $mb = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE gid = ".$mid);
    $a .= "<td><center>";
    $a .= '<a href="'.$mrequrl."&op=kwc&id=".$mid.'">'.$mb."</a>";
    $a .= "</center></td>\n";
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE cid = ".$mid);
    $a .= "<td><center>";
    $a .= '<a href="'.$mrequrl."&op=kwp&id=".$mid.'">'.$mc."</a>&nbsp;&nbsp;";
    $a .= "</center></td>\n";
    if($mc)
      $mctr = $mb/$mc*100;
    else
      $mctr = 0;
    $mctr = sprintf("%.2f",$mctr);
    $a .= "<td><center>".$mctr."%&nbsp;&nbsp;&nbsp;&nbsp;</center></td>";
    $a .= '<td>';
    $a .= '<a href="'.$mrequrl."&op=del&id=".$mid.'"'.">".XLT_TXT030."</a>&nbsp;&nbsp;&nbsp;";
    $a .= '<a href="'.$mrequrl."&op=upd&id=".$mid.'"'.">".XLT_TXT008."</a>";
    $a .= "</td>\n";
    $a .="</tr>";
  }
  $a .= "</table>";
  $a .= "</div></div>";

// Ajouter une campagne

  $a .= '<div class="postbox">';
  $a .="<h3>".XLT_TXT031."</h3>";
  $a .= '<div class="inside">';

  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=add".'" method="post">';
  $a .= "<tr><td>";
  $a .= XLT_TXT004." : ";
  $a .= '<input type="text" size="20" maxlength="20" name="nom">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT005." : ";
  $a .= '<input type="text" size="50" maxlength="100" name="kw">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT006." : ";
  $a .= "</td></tr>";
  $a .= '<tr><td><textarea rows="3" cols="100" name="ads"></textarea>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT007." : ";
  $a .= '<input type="text" size="50" maxlength="100" name="link" value="http://">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" class="button-primary button-side" value="'.XLT_TXT032.'">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";
  $a .= "</div></div>";

// Preferences

  $mhome = get_option('pk_prefs_home');
  if($mhome == '1')
    $mhometxt = "checked";
  else
    $mhometxt = "";

  $mexcerpt = get_option('pk_prefs_excerpt');
  if($mexcerpt == '1')
    $mexcerpttxt = "checked";
  else
    $mexcerpttxt = "";

  $mhide = get_option('pk_prefs_hide');
  if($mhide == '1')
    $mhidetxt = "checked";
  else
    $mhidetxt = "";

  $marchivage = get_option('pk_prefs_archivage');
  if(strlen($marchivage))
    $marchivagetxt = "checked";
  else
    $marchivagetxt = "";

  $mpurge = get_option('pk_prefs_purge');
  if(strlen($mpurge))
    $mpurgetxt = "checked";
  else
    $mpurgetxt = "";

  $mdisart = get_option('pk_prefs_disarticle');
  if($mdisart == '1')
    $mdisarttxt = "checked";
  else
    $mdisarttxt = "";

  $mnumart = get_option('pk_prefs_numarticle');

  $mpurgeday = get_option('pk_prefs_purge_day');
  $marticle = get_option('pk_prefs_article');

  $mnet = get_option('pk_prefs_methode');
  switch($mnet) {
    case 2:
      $mt2 = "checked";
      break;
    case 3:
      $mt3 = "checked";
      break;
    default:
      $mt1 = "checked";
      break;
  }

  $mnet = get_option('pk_prefs_gl');
  if($mnet == '1')
    $mg1 = "checked";
  else
    $mg2 = "checked";

  $mtgtxt = "";
  $mtg = get_option('pk_prefs_tg');
  if($mtg == '1')
    $mtgtxt = "checked";

  $msupertagtxt = "";
  $msupertag = get_option('pk_prefs_supertag');
  if($msupertag == '1')
    $msupertagtxt = "checked";

  $mntgtxt = get_option('pk_prefs_ntg');
  $mhdr = get_option('pk_prefs_hdr');
  
  $mwid1 = get_option('pk_prefs_wid1');
  $mwid2 = get_option('pk_prefs_wid2');

  $mwidhd1 = htmlspecialchars(get_option('pk_prefs_wid_hd1'));
  $mwidhd2 = htmlspecialchars(get_option('pk_prefs_wid_hd2'));
  $mwidhd3 = htmlspecialchars(get_option('pk_prefs_wid_hd3'));
  $mwidhd4 = htmlspecialchars(get_option('pk_prefs_wid_hd4'));

  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT033."</h3>";
  $a .= '<div class="inside">';
  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=prefs".'" method="post">';
  $a .= "<tr><td>";
  $a .= XLT_TXT034." ";
  $a .= '<input type="text" size="2" maxlength="2" name="article" value="'.$marticle.'">';
  $a .= " ".XLT_TXT035;
  $a .= "</td><td></td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT036." : ";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="purge"'.$mpurgetxt.'>';
  $a .= " ".XLT_TXT037." ";
  $a .= '<input type="text" size="2" maxlength="2" name="purgeday" value="'.$mpurgeday.'">';
  $a .= " ".XLT_TXT038;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT039." : ";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="disart"'.$mdisarttxt.'>';
  $a .= " ".XLT_TXT040." ";
  $a .= '<input type="text" size="2" maxlength="2" name="numart" value="'.$mnumart.'">';
  $a .= " ".XLT_TXT041;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT042." : ";
  $a .= "</td><td>";
  $a .= '<input type="text" size="20" maxlength="30" name="mhdr" value="'.$mhdr.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT043.":";
  $a .= "</td><td>";
  $a .= '<input type="radio" name="mtd" '.$mt1.' value="1">'.XLT_TXT044.'&nbsp;&nbsp;';
  $a .= '<input type="radio" name="mtd" '.$mt2.' value="2">'.XLT_TXT045.'&nbsp;&nbsp;';
  $a .= '<input type="radio" name="mtd" '.$mt3.' value="3">'.XLT_TXT046;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT068.":";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="mexcerpt"'.$mexcerpttxt.'>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT069.":";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="mhome"'.$mhometxt.'>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT070.":";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="mhide"'.$mhidetxt.'>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT047.": ";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="mtg"'.$mtgtxt.'>';
  $a .= " ".XLT_TXT040." ";
  $a .= '<input type="text" size="2" maxlength="2" name="mntg" value="'.$mntgtxt.'">';
  $a .= " ".XLT_TXT048;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT049.":";
  $a .= "</td><td>";
  $a .= '<input type="radio" name="mgl" '.$mg1.' value="1">'.XLT_TXT050.'&nbsp;&nbsp;';
  $a .= '<input type="radio" name="mgl" '.$mg2.' value="2">'.XLT_TXT051;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT052." (<b>xlt.csv</b>): ";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="marc"'.$marchivagetxt.'>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT076.":";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="msupertag"'.$msupertagtxt.'>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT034." ";
  $a .= '<input type="text" size="2" maxlength="2" name="wid1" value="'.$mwid1.'">';
  $a .= " ".XLT_TXT053;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT034." ";
  $a .= '<input type="text" size="2" maxlength="2" name="wid2" value="'.$mwid2.'">';
  $a .= " ".XLT_TXT054;
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT071.":";
  $a .= '<input type="text" size="20" maxlength="200" name="widhd1" value="'.$mwidhd1.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT073.":";
  $a .= '<input type="text" size="20" maxlength="200" name="widhd2" value="'.$mwidhd2.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT074.":";
  $a .= '<input type="text" size="20" maxlength="200" name="widhd3" value="'.$mwidhd3.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= XLT_TXT072.":";
  $a .= '<input type="text" size="20" maxlength="200" name="widhd4" value="'.$mwidhd4.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" class="button-primary button-side" value="'.XLT_TXT008.'">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";
  $a .= "</div></div>";

  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT084."</h3>";
  $a .= '<div class="inside">';
  $a .= '<form action="'.$mrequrl."&op=addbl".'" method="post">';
  $a .= "<table>";
  $a .= "<tr><td>";
  $a .= XLT_TXT085.":";
  $a .= "</td><td>";
  $a .= '<input type="text" size="30" maxlength="250" name="mkw">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" class="button-primary button-side" value="'.XLT_TXT086.'">';
  $a .= "</td></tr>";
  $a .= "</table>";
  $a .= "</form>";
  $a .= "<br />";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .= "<tr><td><center><b>".XLT_TXT001."</b></center></td><td><center><b>".XLT_TXT029."</b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT id,bl FROM ".$wpdb->prefix . "pk_bl");
  foreach ($sql as $res) {
    $mbl = base64_decode($res->bl);
    $a .= "<tr><td>".$mbl."</td>";
    $a .= '<td><a href="'.$mrequrl."&op=rembl&id=".$res->id.'">'.XLT_TXT089."</a></td>";
    $a .= "</tr>\n";
  }
  $a .= "</table>";
  $a .= "</div>";
  $a .= "</div>";

  $a .= "<br />";
  $a .= "<table>";
  $a .= "<tr><td>";
  $a .= '<center>(C)2011-2013 <a href="http://www.pagasa.net" target="_blank">Thibaut Maquet</a></center>';
  $a .= "</td></tr>";
  $a .= "</table>";
  $a .= "</div>";
  echo $a;
}

function pk_admin_prefs_save() {

  if(isset($_POST['widhd1']))
    update_option('pk_prefs_wid_hd1',htmlspecialchars_decode($_POST['widhd1']));
  if(isset($_POST['widhd2']))
    update_option('pk_prefs_wid_hd2',htmlspecialchars_decode($_POST['widhd2']));
  if(isset($_POST['widhd3']))
    update_option('pk_prefs_wid_hd3',htmlspecialchars_decode($_POST['widhd3']));
  if(isset($_POST['widhd4']))
    update_option('pk_prefs_wid_hd4',htmlspecialchars_decode($_POST['widhd4']));

  if(isset($_POST['wid1'])) {
    $mrs = $_POST['wid1'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT055);
    update_option('pk_prefs_wid1',$mrs);
  }

  if(isset($_POST['wid2'])) {
    $mrs = $_POST['wid2'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT056);
    update_option('pk_prefs_wid2',$mrs);
  }

  if(isset($_POST['mhide'])) {
    update_option('pk_prefs_hide','1');
  }
  else {
    update_option('pk_prefs_hide','0');
  }

  if(isset($_POST['mhome'])) {
    update_option('pk_prefs_home','1');
  }
  else {
    update_option('pk_prefs_home','0');
  }

  if(isset($_POST['mexcerpt'])) {
    update_option('pk_prefs_excerpt','1');
  }
  else {
    update_option('pk_prefs_excerpt','0');
  }

  if(isset($_POST['msupertag']))
    update_option('pk_prefs_supertag','1');
  else
    update_option('pk_prefs_supertag','0');

  if(isset($_POST['marc']))
    add_option('pk_prefs_archivage','1','','yes');
  else
    delete_option('pk_prefs_archivage');

  if(isset($_POST['purge']))
    add_option('pk_prefs_purge','1','','yes');
  else
    delete_option('pk_prefs_purge');

  if(isset($_POST['purgeday'])) {
    $mrs = $_POST['purgeday'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT057);
    update_option('pk_prefs_purge_day',$mrs);
  }

  if(isset($_POST['numart'])) {
    $mrs = $_POST['numart'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT058);
    update_option('pk_prefs_numarticle',$mrs);
  }

  if(isset($_POST['article'])) {
    $mrs = $_POST['article'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT059);
    update_option('pk_prefs_article',$mrs);
  }

  if(isset($_POST['mtg']))
    update_option('pk_prefs_tg','1');
  else
    update_option('pk_prefs_tg','0');
  if(isset($_POST['mntg'])) {
    $mrs = $_POST['mntg'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu(XLT_TXT060);
    update_option('pk_prefs_ntg',$mrs);
  }

  if(isset($_POST['mexcerpt'])) {
    add_filter('the_excerpt', 'pk_filter', 25);
    update_option('pk_prefs_excerpt','1');
  }
  else {
    update_option('pk_prefs_excerpt','0');
    remove_filter('the_excerpt', 'pk_filter');
  }
  if(isset($_POST['disart']))
    update_option('pk_prefs_disarticle','1');
  else
    update_option('pk_prefs_disarticle','0');

  if(isset($_POST['mtd'])) {
    $m = $_POST['mtd'];
    update_option('pk_prefs_methode',$m);
  }

  if(isset($_POST['mgl'])) {
    $m = $_POST['mgl'];
    update_option('pk_prefs_gl',$m);
  }

  if(isset($_POST['mhdr'])) {
    $m = $_POST['mhdr'];
    update_option('pk_prefs_hdr',$m);
  }

  pk_admin_menu(XLT_TXT061);

}


function pk_savetag($mid){
  global $wpdb;
  if(isset($_POST['valid'])) {
    if(isset($_POST['msupertag'])) {
      $mtag = $_POST['msupertag'];
      $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_supertag WHERE postid = '".$mid."'");
      if(!$mc) 
        $sql = "INSERT INTO ".$wpdb->prefix . "pk_supertag ( `postid`,`tagid`) VALUES ('".$mid."','".$mtag."')";
      else
        $sql = "UPDATE ".$wpdb->prefix . "pk_supertag SET `tagid` = '".$mtag."' WHERE `postid` = '".$mid."'";
      $wpdb->query($sql);
    }
    pk_admin_menu(XLT_TXT081);
  }
  else
    if(isset($_POST['supp'])) {
      $sql = "DELETE FROM ".$wpdb->prefix . "pk_supertag WHERE `postid` = '".$mid."'";
      $wpdb->query($sql);
      pk_admin_menu(XLT_TXT083);
    }
}

function pk_admin_supertag($mid) {
  global $wpdb;

  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&id=(.*)+/","",$mrequrl);

  $a = "";
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT077."</h3>";
  $a .= '<div class="inside">';

  $i = 0;
  $mtags = wp_get_post_tags($mid);
  $t = "";
  foreach($mtags as $mtag) {
    $mtab0[$i] = $mtag->term_id; 
    $mtab1[$i++] = $mtag->name;
  }
  if(!$i) {
    $a .= "<h4>".XLT_TXT078."</h4>";
  }
  else {
    $mc =  $wpdb->get_var("SELECT tagid FROM ".$wpdb->prefix . "pk_supertag WHERE postid = '".$mid."'");
    $a .= '<form action="'.$mrequrl."&op=savetag&id=".$mid.'" method="post">';
    $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
    $a .= "<tr><td><center><b>".XLT_TXT075."</b></center></td><td><center><b>".XLT_TXT079."</b></center></td></tr>";
    for($j=0;$j<$i;$j++) {
      $a .= "<tr>";
      $a .= "<td>".$mtab1[$j]."</td>";
        $mchecked = "";
      if($mc == $mtab0[$j])
        $mchecked = "checked";
      $a .= '<td><center><input type="radio" name="msupertag" '.$mchecked.' value="'.$mtab0[$j].'"></center></td>';
      $a .= "</tr>";
    }
    $a .= "<tr><td>";
    $a .= '<input type="submit" name = "valid" class="button-primary button-side" value="'.XLT_TXT080.'">';
    $a .= "</td><td>";
    $a .= '<input type="submit" name = "supp" class="button-primary button-side" value="'.XLT_TXT082.'">';
    $a .= "</td></tr>";
    $a .= "</table>";
    $a .= "</form>";
  }
  $a .= "</div>";
  echo $a;

}

function pk_admin_kws($mid) {
  global $wpdb;

  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&id=(.*)+/","",$mrequrl);

  $mpost = get_post($mid);
  $mt = array();

  $a = "";
  $a .= '<div class="postbox-container" style="width: 80%">';
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT062." '".$mpost->post_title."'</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b><a href=".'"'.$mrequrl."&op=kww&id=".$mid.'">'.XLT_TXT017."</a</b></center></td></tr><tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a .= "<tr>";
    $a .= "<td>".strftime(XLT_TXT020." ".XLT_TXT019,$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."</td>";
    $a .= "</tr>\n";
    $mt[0][strftime(XLT_TXT020,$res->ts)] = strftime(XLT_TXT020,$res->ts);
    $mt[1][strftime(XLT_TXT020,$res->ts)] = $mt[1][strftime(XLT_TXT020,$res->ts)]+1;
  }
  $a .= "</tr></table>";
  $a .= "</div></div>";
  $b = array();
  $i = 0;
  foreach($mt[0] as $res) {
    $b[$i++] = $res;
  }
  $c = array();
  $i = 0;
  foreach($mt[1] as $res) {
    $c[$i++] = $res;
  }

  $n = 0;
  $a .= '<div class="postbox">';
  $a .= "<h3>". XLT_TXT067."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT063."</b></center></td></tr>";
  for($j = 0;$j<$i;$j++) {
    $a .= "<tr><td>".$b[$j]."&nbsp;&nbsp;-&nbsp;&nbsp;</td><td><center>".$c[$j]."</center></td></tr>\n";
    $n = $n + $c[$j];
  }
  $a .= "</tr>";
  $a .= "<tr><td><center>===</center></td><td><center><b>";
  $a .= $n."</b></center></td></tr>";
  $a .= "</table>";
  $a .= "</div></div>";
  $a .= "</div>";
  echo $a;
}

function pk_sort($mid) {
  global $wpdb;
  $mkeys = array();
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $mks = explode(" ",$res->kw);
    foreach ($mks as $mk) {
      $mkeys[0][$mk] = $mk;
      $mkeys[1][$mk] = $mkeys[1][$mk]+1;
    }
  }
  $mp = array();
  $i = 0;
  foreach ($mkeys[0] as $res) {
    $mp[0][$i] = $res;
    $mp[1][$i++] = $mkeys[1][$res];  
  }

  for($j=0;$j<$i;$j++) {
    for($k=0;$k<$i;$k++) {
      if($mp[1][$k] < $mp[1][$k+1]) {
        $t1 = $mp[1][$k];
        $mp[1][$k] = $mp[1][$k+1];
        $mp[1][$k+1] = $t1;
        $t1 = $mp[0][$k];
        $mp[0][$k] = $mp[0][$k+1];
        $mp[0][$k+1] = $t1;
      }
    }
  }

  $a = "<h3>".XLT_TXT064."</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT017."</b></center></td><td><center><b>".XLT_TXT063."</b></center></td></tr><tr>";

  for($l=0;$l<$i;$l++) {
    $a .= "<tr><td>".$mp[0][$l]."</td><td><center>".$mp[1][$l]."</center></td></tr>\n";
  }

  $a .= "</table>";
  echo $a;
}

function pk_tot() {
  global $wpdb;

  $a = "";

  $a .= '<div class="postbox-container" style="width: 80%">';
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT065."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT017."</b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a .= "<tr><td>".strftime(XLT_TXT020." ".XLT_TXT019,$res->ts).'&nbsp;&nbsp;-&nbsp;&nbsp;</td><td><a href="http://'.getenv("HTTP_HOST").'/?p='.$res->postid.'" target="_blank">'.$res->kw."</a></td></tr>\n";
  }
  $a .= "</table>";
  $a .= "</div></div>";
  $a .= "<br />";  

  $n = 0;
  $a .= '<div class="postbox">';
  $a .= "<h3>".XLT_TXT066."</h3>";
  $a .= '<div class="inside">';
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT016."</b></center></td><td><center><b>".XLT_TXT063."</b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw ORDER BY ts DESC");
  foreach ($sql as $res) {
    $b = strftime("%G%m%d",$res->ts);
    if($b1 != $b && $n) {
      $a .= "<tr><td>".$d."</td><td><center>".$m."<center></td></tr>\n";
      $m = 0;
    }
    $b1 = $b;
    $d = strftime("%d/%m/%G",$res->ts);
    $n++;
    $m++;
  }
  $a .= "<tr><td>".$d."</td><td><center>".$m."<center></td></tr>\n";
  $a .= "</table>";
  $a .= "</div></div>";
  $a .= "</div>";
  echo $a;
}

function pk_main_sort() {
  global $wpdb;
  $mkeys = array();
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw");
  foreach ($sql as $res) {
    $mks = explode(" ",$res->kw);
    foreach ($mks as $mk) {
      $mkeys[0][$mk] = $mk;
      $mkeys[1][$mk] = $mkeys[1][$mk]+1;
    }
  }
  $mp = array();
  $i = 0;
  foreach ($mkeys[0] as $res) {
    $mp[0][$i] = $res;
    $mp[1][$i++] = $mkeys[1][$res];
  }

  for($j=0;$j<$i;$j++) {
    for($k=0;$k<$i;$k++) {
      if($mp[1][$k] < $mp[1][$k+1]) {
        $t1 = $mp[1][$k];
        $mp[1][$k] = $mp[1][$k+1];
        $mp[1][$k+1] = $t1;
        $t1 = $mp[0][$k];
        $mp[0][$k] = $mp[0][$k+1];
        $mp[0][$k+1] = $t1;
      }
    }
  }

  $a = "<h3>".XLT_TXT064."</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>".XLT_TXT017."</b></center></td><td><center><b>".XLT_TXT063."</b></center></td></tr><tr>";

  for($l=0;$l<$i;$l++) {
    $a .= "<tr><td>".sprintf("%50.50s",$mp[0][$l])."</td><td><center>".$mp[1][$l]."</center></td></tr>\n";
  }

  $a .= "</table>";
  echo $a;
}

function pk_addbl() {
  global $wpdb;
  if(isset($_POST['mkw'])){
    $mkw = $_POST['mkw'];
    if(!strlen($mkw))
      return pk_admin_menu(XLT_TXT087);
    $mkw = base64_encode($mkw);
    $sql = "INSERT INTO ".$wpdb->prefix . "pk_bl ( `bl`) VALUES ('".$mkw."')";
    $wpdb->query($sql);
    return pk_admin_menu(XLT_TXT088);
  }
  else
    return pk_admin_menu(XLT_TXT087);
}

function pk_rembl($mid) {
  global $wpdb;
  if(strlen($mid)) {
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_bl WHERE id = ".$mid);
    if($mc) {
      $sql = "DELETE FROM ".$wpdb->prefix . "pk_bl WHERE id = '".$mid."'";
      $wpdb->query($sql);
      return pk_admin_menu(XLT_TXT090);  
    }
  }
  return pk_admin_menu(XLT_TXT087);
}


function pk_display_settings() {
  $mop = (isset($_GET['op'])) ? $_GET['op'] : "0";
  $mid = (isset($_GET['id'])) ? $_GET['id'] : "0";
  $mst = (isset($_GET['st'])) ? $_GET['st'] : "0";

  update_option('pk_prefs_sortop',$mst);

  switch($mop) {
    case "rembl":
      pk_rembl($mid);
      break;
    case "addbl":
      pk_addbl();
      break;
    case "savetag":
      pk_savetag($mid);
      break;
    case "tag":
      pk_admin_supertag($mid);
      break;
    case "kws":
      pk_admin_kws($mid);
      break;
    case "prefs":
      pk_admin_prefs_save();
      break;
    case "add":
      pk_admin_add();
      break;
    case "del":
      pk_admin_del($mid);
      break;
    case "upd":
      pk_admin_update($mid);
      break;
    case "mod":
      pk_admin_mod($mid);
      break;
    case "kwp":
      pk_print($mid);
      break;
    case "kww":
      pk_sort($mid);
      break;
    case "kwc":
      pk_clic($mid);
      break;
    case "kwv":
      pk_main_sort();
      break;
    case "tot":
      pk_tot();
      break;
    default:
      pk_admin_menu("");
      break;
  }
}

function pk_admin_prefs() {
  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
}

function pk_widget_display($args) {
  global $wpdb;
  extract($args);
  $data = get_option('pk_wid_data');

  $t = "";
  $t .= $args['before_widget'];
  $t .= $args['before_title'] .$data['title'] .$args['after_title'];

  $t .= get_option('pk_wid');
  $t .= $args['after_widget'];
  echo $t;
}

function pk_widget_control() {
  $mdata = get_option('pk_wid_data');
  $a = '<p><label>Titre:</label> <input name="pk_wid_title" type="text" value="';
  $a .=  $mdata['title'];
  $a .=  '" /></p>';
  echo $a;
  if (isset($_POST['pk_wid_title'])) {
    $mdata['title'] = attribute_escape($_POST['pk_wid_title']);
    update_option('pk_wid_data', $mdata);
  }
}

function pk_init_widget() {
  wp_register_sidebar_widget('pk_widget','XLT Widget','pk_widget_display',array('name'=>'XLT Widget','description' => 'XLT widget'));
  wp_register_widget_control('pk_widget','XLT Widget','pk_widget_control');
}



//
// Routine Cron 
//

function pk_cron() {
  global $wpdb;
  $mhd1 = get_option('pk_prefs_wid_hd1');
  $mhd2 = get_option('pk_prefs_wid_hd2');
  $mhd3 = get_option('pk_prefs_wid_hd3');
  $mhd4 = get_option('pk_prefs_wid_hd4');

  $m = "";
  $mwid1 = get_option('pk_prefs_wid1');
  $i = 0;
  $sql = $wpdb->get_results("SELECT COUNT(*),kw,postid FROM `".$wpdb->prefix . "pk_kw` GROUP BY kw ORDER BY 1 DESC LIMIT ".$mwid1*20);
  foreach ($sql as $res) {
    $mid = $res->postid;
    $mkw =$res->kw;
    $t[$i][0] = $mid;
    $t[$i++][1] = $mkw;
  }
    
  $m .= $mhd1;
  $ok = 1;
  $i = 0;
  $j = 0;
  while($ok) {
    $ok1 = 1;
    for($i1=0;$i1<$j;$i1++) {
      if($t[$i][0] == $tab[$i1])
        $ok1 = 0;
    }
    if($ok1) {
      $tab[$j] = $t[$i][0];
      $mkw = $t[$i][1];
      $murl = get_permalink($t[$i][0]);
      $m .= $mhd2.'<a href="'.$murl.'"'.' title="'.$mkw.'">'.$mkw."</a>".$mhd3;
      $j++;
    }
    $i++;
    if($i == $mwid1*20 || $j == $mwid1)
      $ok = 0;
  }

  $sql = $wpdb->get_results("SELECT $wpdb->posts.ID FROM $wpdb->posts WHERE $wpdb->posts.post_status='publish' AND $wpdb->posts.post_type = 'post' ORDER BY $wpdb->posts.ID DESC LIMIT 1");
  foreach ($sql as $res) {
    $j = $res->ID;
  }

  $sql = $wpdb->get_results("SELECT $wpdb->posts.ID FROM $wpdb->posts WHERE $wpdb->posts.post_status='publish' AND $wpdb->posts.post_type = 'post' ORDER BY $wpdb->posts.ID LIMIT 1");
  foreach ($sql as $res) {
    $mid = $res->ID;
  }
  $mx = get_option('pk_prefs_wid2');
  $nx = 0;
  
  $i = 0;
  while ($nx != $mx) {
    $md = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = '".$mid."'");
    if(!$md) {
      $mpost = get_post($mid);
      $murl = get_permalink($mid);
      $mtags = wp_get_post_tags($mid);
      $mkw = "";
      $l = 0;
      foreach($mtags as $mtag) {
        if($l<4)
          $mkw .= $mtag->name. " ";
        $l++;
      }
      if(!strlen($mkw)) {
        $mkw = $mpost->post_title;
      }
      $m .= $mhd2.'<a href="'.$murl.'"'.' title="'.$mkw.'">'.$mpost->post_title."</a>".$mhd3;
      $nx++;
    }
    else
      $i++;
    $sql = $wpdb->get_results("SELECT $wpdb->posts.ID FROM $wpdb->posts WHERE $wpdb->posts.post_status='publish' AND $wpdb->posts.post_type = 'post' AND $wpdb->posts.ID > $mid ORDER BY $wpdb->posts.ID LIMIT 1");
    foreach ($sql as $res) {
      $mid = $res->ID;
    }
    if($i == $j)
      $nx = $mx;
  }

  $m .= $mhd4;
  update_option('pk_wid', $m);

}

function pk_cron1() {
  global $wpdb;

  $a = "";
  $mm = 4;
 
  $mo = get_option('pk_wid_first');
  list($pid,$mts) = explode(";",$mo);
  $f1 = 0;
  if($pid == '0')
    $f1 = 1;
  else {
    $md = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = '".$pid."'");
    if($md) { 
      update_option('pk_wid_first',"0;0");
      $f1 = 1;
    }
    else {
      $mtt =  mktime() - (60 * 60 * 24 * 4);
      if($mtt > $mts) {
        update_option('pk_wid_first',"0;0");
        $f1 = 1;
      }
    }
  }

  if(!$f1)
    $mm = 3;

  $m = 0;
  $n = 0;
  $ok = 1;
  while($ok) {
    $msec = get_option('pk_seq');
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE $wpdb->posts.post_status = 'publish' AND $wpdb->posts.post_type = 'post' AND $wpdb->posts.ID > ".$msec);
    if($mc) {
      $sql = $wpdb->get_results("SELECT $wpdb->posts.ID FROM $wpdb->posts WHERE $wpdb->posts.post_status='publish' AND $wpdb->posts.post_type = 'post' AND $wpdb->posts.ID >".$msec." LIMIT 1");
      foreach ($sql as $res) {
        $mid = $res->ID;
        update_option('pk_seq',$res->ID);
      }
      $md = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = '".$mid."'");
      if(!$md) {
        $m++;

        if($f1 == 1 && $m == 1)
          update_option('pk_wid_first',$res->ID.";".mktime());
 
        $mpost = get_post($mid);
        $murl = get_permalink($mid);
        $mtags = wp_get_post_tags($mid);
        $mkw = "";
        $l = 0;
        foreach($mtags as $mtag){
          if($l<4)
            $mkw .= $mtag->name. " ";
          $l++;
        }
        if(!strlen($mkw)) {
          $mkw = $mpost->post_title;
        }
        $a .= '<a href="'.$murl.'"'.' title="'.$mkw.'">'.$mkw."</a><br />";
      }
    }
    else {
      update_option('pk_seq','0');
    }
    $n++;
    if($n == 50 || $m == $mm)
      $ok = 0;
  }
  $k = 6 - $m;

  $b = "SELECT kw,postid FROM ".$wpdb->prefix . "pk_kw ORDER BY ts DESC LIMIT ".$k;
  $sql = $wpdb->get_results($b);
  foreach ($sql as $res) {
    $mid = $res->postid;
    $mkw = $res->kw;
    $mpost = get_post($mid);
    $murl = get_permalink($mid);
    $a .= '<a href="'.$murl.'"'.' title="'.$mkw.'">'.$mkw."</a><br />";
  }

  if(!$f1) {
    $mpost = get_post($pid);
    $murl = get_permalink($pid);
    $mtags = wp_get_post_tags($pid);
    $mkw = "";
    $l = 0;
    foreach($mtags as $mtag){
      if($l<4)
        $mkw .= $mtag->name. " ";
      $l++;
    }
    if(!strlen($mkw)) {
      $mkw = $mpost->post_title;
    }
    $a .= '<a href="'.$murl.'"'.' title="'.$mkw.'">'.$mkw."</a><br />";
  }

  update_option('pk_wid',$a);
}

require_once(ABSPATH . 'wp-includes/plugin.php');
$a = plugin_dir_path( __FILE__ )."francais.php";
include($a);
register_activation_hook(__FILE__,'pk_init');
register_deactivation_hook(__FILE__,'pk_deinit');

add_filter('the_content', 'pk_filter', 25);
add_filter('the_excerpt', 'pk_filter', 25);

add_action('admin_menu', 'pk_admin_settings');
add_action("plugins_loaded", "pk_init_widget");
add_action( 'pk_hook', 'pk_cron');
add_action( 'wp_enqueue_scripts', 'pk_styles'); 
